diff -uwr sourceold/CTF/CTF.cpp source/CTF/CTF.cpp
--- sourceold/CTF/CTF.cpp	2011-10-11 21:33:14.455078100 +0800
+++ source/CTF/CTF.cpp	2011-12-07 11:55:00.500000000 +0800
@@ -55,19 +55,15 @@
 class CTF : public Plugin
 {
 public:
-	int CTFClass;
-	StringClass CTFClassName;
-	bool CTFEnableReverse;
-	bool CTFReverse;
+	struct Configuration {
+		int CTFCapLimit;
+		Vector3 CTFFlagOffset;
 	bool CTFRegenForHolder;
 	float CTFRegenAmount;
 	StringClass CTFFlagPreset;
 	StringClass CTFFlagModel[2];
 	StringClass CTFFlagBackPreset;
 	StringClass CTFPedPreset[2];
-	int CTFCapLimit;
-	Vector3 CTFFlagOffset;
-	Vector3 CTFPedPos[2];
 	float CTFCapPoints;
 	float CTFCapPointsTeam;
 	float CTFCapMoney;
@@ -75,12 +71,46 @@
 	float CTFReturnTime;
 	bool CTFFriendlyFlagRadar;
 	bool CTFEnemyFlagRadar;
+		bool CTFEnableReverse;
+		int CTFClass;
+		StringClass CTFClassName;
+		bool CTFReverse;
+		Vector3 CTFPedPos[2];
+		void setToDefaults()
+		{
+			CTFCapLimit = 3;
+			CTFFlagOffset = Vector3(0,0,0);
+			CTFRegenForHolder = false;
+			CTFRegenAmount = 2.0;
+			CTFFlagPreset = "POW_Data_Disc";
+			CTFFlagModel[0] = "o_flag";
+			CTFFlagModel[1] = "o_flag";
+			CTFFlagBackPreset = "CtfFlag";
+			CTFPedPreset[0] = "CtfPedestalRed";
+			CTFPedPreset[1] = "CtfPedestalGold";
+			CTFCapPoints = 0;
+			CTFCapPointsTeam = 0;
+			CTFCapMoney = 0;
+			CTFCapMoneyTeam = 0;
+			CTFReturnTime = 120;
+			CTFFriendlyFlagRadar = false;
+			CTFEnemyFlagRadar = false;
+			CTFEnableReverse = false;
+			CTFClass = 0;
+			CTFClassName = "NULL";
+			CTFReverse = false;
+			CTFPedPos[0] = Vector3(0,0,0);
+			CTFPedPos[1] = Vector3(0,0,0);
+		}
+	};
 	int CTFFlagHolder[2];
 	int CTFFlagAttached[2][2];
 	int CTFCaps[2];
 	int CTFFlagLoc[2];
 	int CTFFlagIcon[2];
-	CTF() : CTFCapLimit(0), CTFRegenForHolder(false), CTFRegenAmount(0), CTFCapPoints(0), CTFCapPointsTeam(0), CTFCapMoney(0), CTFCapMoneyTeam(0), CTFReturnTime(0), CTFFriendlyFlagRadar(false), CTFEnemyFlagRadar(false), CTFEnableReverse(false)
+	Configuration globalConfiguration;
+	Configuration mapConfiguration;
+	CTF()
 	{
 		CTFFlagHolder[0] = 0;
 		CTFFlagHolder[1] = 0;
@@ -93,6 +123,7 @@
 		RegisterEvent(EVENT_CHAT_HOOK,this);
 		RegisterEvent(EVENT_GAME_OVER_HOOK,this);
 		RegisterEvent(EVENT_GLOBAL_INI,this);
+		RegisterEvent(EVENT_MAP_INI,this);
 		RegisterEvent(EVENT_LOAD_LEVEL_HOOK,this);
 		RegisterEvent(EVENT_OBJECT_CREATE_HOOK,this);
 		RegisterEvent(EVENT_PLAYER_JOIN_HOOK,this);
@@ -102,34 +133,45 @@
 		UnregisterEvent(EVENT_CHAT_HOOK,this);
 		UnregisterEvent(EVENT_GAME_OVER_HOOK,this);
 		UnregisterEvent(EVENT_GLOBAL_INI,this);
+		UnregisterEvent(EVENT_MAP_INI,this);
 		UnregisterEvent(EVENT_LOAD_LEVEL_HOOK,this);
 		UnregisterEvent(EVENT_OBJECT_CREATE_HOOK,this);
 		UnregisterEvent(EVENT_PLAYER_JOIN_HOOK,this);
 	}
+	void LoadGenericINISettings(INIClass *SSGMIni, const char* key, Configuration& configuration)
+	{
+		configuration.CTFCapLimit = SSGMIni->Get_Int("CTF","CaptureLimit",configuration.CTFCapLimit);
+		configuration.CTFFlagOffset.X = SSGMIni->Get_Float("CTF","FlagOffsetx",configuration.CTFFlagOffset.X);
+		configuration.CTFFlagOffset.Y = SSGMIni->Get_Float("CTF","FlagOffsety",configuration.CTFFlagOffset.Y);
+		configuration.CTFFlagOffset.Z = SSGMIni->Get_Float("CTF","FlagOffsetz",configuration.CTFFlagOffset.Z);
+		configuration.CTFRegenForHolder = SSGMIni->Get_Bool("CTF","EnableRegenForHolder",configuration.CTFRegenForHolder);
+		configuration.CTFRegenAmount = SSGMIni->Get_Float("CTF","RegenAmount",configuration.CTFRegenAmount);
+		SSGMIni->Get_String(configuration.CTFFlagPreset,"CTF","FlagPresetName",configuration.CTFFlagPreset);
+		SSGMIni->Get_String(configuration.CTFFlagModel[0],"CTF","FlagModelName0",configuration.CTFFlagModel[0]);
+		SSGMIni->Get_String(configuration.CTFFlagModel[1],"CTF","FlagModelName1",configuration.CTFFlagModel[1]);
+		SSGMIni->Get_String(configuration.CTFFlagBackPreset,"CTF","CarriedFlagPresetName",configuration.CTFFlagBackPreset);
+		SSGMIni->Get_String(configuration.CTFPedPreset[0],"CTF","PedestalPresetName0",configuration.CTFPedPreset[0]);
+		SSGMIni->Get_String(configuration.CTFPedPreset[1],"CTF","PedestalPresetName1",configuration.CTFPedPreset[1]);
+		configuration.CTFCapPoints = SSGMIni->Get_Float("CTF","CapturePoints",configuration.CTFCapPoints);
+		configuration.CTFCapPointsTeam = SSGMIni->Get_Float("CTF","CapturePointsTeam",configuration.CTFCapPointsTeam);
+		configuration.CTFCapMoney = SSGMIni->Get_Float("CTF","CaptureMoney",configuration.CTFCapMoney);
+		configuration.CTFCapMoneyTeam = SSGMIni->Get_Float("CTF","CaptureMoneyTeam",configuration.CTFCapMoneyTeam);
+		configuration.CTFReturnTime = SSGMIni->Get_Float("CTF","ReturnDropFlagTime",configuration.CTFReturnTime);
+		configuration.CTFFriendlyFlagRadar = SSGMIni->Get_Bool("CTF","ShowFriendlyFlagRadar",configuration.CTFFriendlyFlagRadar);
+		configuration.CTFEnemyFlagRadar = SSGMIni->Get_Bool("CTF","ShowEnemyFlagRadar",configuration.CTFEnemyFlagRadar);
+		configuration.CTFEnableReverse = SSGMIni->Get_Bool("CTF","EnableReverseCTF",configuration.CTFEnableReverse);
+	}
 	virtual void OnLoadGlobalINISettings(INIClass *SSGMIni)
 	{
-		CTFCapLimit = SSGMIni->Get_Int("CTF","CaptureLimit",3);
-		CTFFlagOffset.X = SSGMIni->Get_Float("CTF","FlagOffsetx",0);
-		CTFFlagOffset.Y = SSGMIni->Get_Float("CTF","FlagOffsety",0);
-		CTFFlagOffset.Z = SSGMIni->Get_Float("CTF","FlagOffsetz",0);
-		CTFRegenForHolder = SSGMIni->Get_Bool("CTF","EnableRegenForHolder",false);
-		CTFRegenAmount = SSGMIni->Get_Float("CTF","RegenAmount",2.0);
-		SSGMIni->Get_String(CTFFlagPreset,"CTF","FlagPresetName","POW_Data_Disc");
-		SSGMIni->Get_String(CTFFlagModel[0],"CTF","FlagModelName0","o_flag");
-		SSGMIni->Get_String(CTFFlagModel[1],"CTF","FlagModelName1","o_flag");
-		SSGMIni->Get_String(CTFFlagBackPreset,"CTF","CarriedFlagPresetName","CtfFlag");
-		SSGMIni->Get_String(CTFPedPreset[0],"CTF","PedestalPresetName0","CtfPedestalRed");
-		SSGMIni->Get_String(CTFPedPreset[1],"CTF","PedestalPresetName1","CtfPedestalGold");
-		CTFCapPoints = SSGMIni->Get_Float("CTF","CapturePoints",0);
-		CTFCapPointsTeam = SSGMIni->Get_Float("CTF","CapturePointsTeam",0);
-		CTFCapMoney = SSGMIni->Get_Float("CTF","CaptureMoney",0);
-		CTFCapMoneyTeam = SSGMIni->Get_Float("CTF","CaptureMoneyTeam",0);
-		CTFReturnTime = SSGMIni->Get_Float("CTF","ReturnDropFlagTime",120);
-		CTFFriendlyFlagRadar = SSGMIni->Get_Bool("CTF","ShowFriendlyFlagRadar",false);
-		CTFEnemyFlagRadar = SSGMIni->Get_Bool("CTF","ShowEnemyFlagRadar",false);
-		CTFEnableReverse = SSGMIni->Get_Bool("CTF","EnableReverseCTF",false);
-
-		int Class = SSGMIni->Get_Int("CTF","ForceClass",0);
+		globalConfiguration.setToDefaults();
+		LoadGenericINISettings(SSGMIni, "CTF", globalConfiguration);
+	}
+	virtual void OnLoadMapINISettings(INIClass *SSGMIni)
+	{
+		mapConfiguration = globalConfiguration;
+		const StringClass key = StringClass(The_Game()->Get_Map_Name()).AsLower() + "_CTF";
+		LoadGenericINISettings(SSGMIni, key, mapConfiguration);
+		int Class = SSGMIni->Get_Int(key,"ForceClass",0);
 		if (!Class)
 		{
 			DynamicVectorClass<int> Classes;
@@ -137,18 +179,18 @@
 				StringClass Value;
 				StringClass v;
 				v.Format("CTF_C%02d_Name",z);
-				SSGMIni->Get_String(Value,"CTF",v,"NULL");
+				SSGMIni->Get_String(Value,key,v,"NULL");
 				if (Value == "NULL") {
 					break;
 				}
 				bool Enabled,Reverse;
 				v.Format("CTF_C%02d_Enabled",z);
-				Enabled = SSGMIni->Get_Bool("CTF",v,true);
+				Enabled = SSGMIni->Get_Bool(key,v,true);
 				v.Format("CTF_C%02d_Reverse",z);
-				Reverse = SSGMIni->Get_Bool("CTF",v,false);
+				Reverse = SSGMIni->Get_Bool(key,v,false);
 				if (Enabled) {
 					if (Reverse) {
-						if (CTFEnableReverse) {
+						if (mapConfiguration.CTFEnableReverse) {
 							Classes.Add(z);
 						}
 					}
@@ -169,26 +211,26 @@
 			}
 		}
 
-		CTFClass = Class;
+		mapConfiguration.CTFClass = Class;
 		StringClass v;
-		v.Format("CTF_C%02d_Name",CTFClass);
-		SSGMIni->Get_String(CTFClassName,v,"NULL");
-		v.Format("CTF_C%02d_Reverse",CTFClass);
-		CTFReverse = SSGMIni->Get_Bool("CTF",v,false);
-		v.Format("CTF_C%02d_CaptureLimit",CTFClass);
-		CTFCapLimit = SSGMIni->Get_Int("CTF",v,CTFCapLimit);
-		v.Format("CTF_C%02d_Team0x",CTFClass);
-		CTFPedPos[0].X = SSGMIni->Get_Float("CTF",v,0.0f);
-		v.Format("CTF_C%02d_Team0y",CTFClass);
-		CTFPedPos[0].Y = SSGMIni->Get_Float("CTF",v,0.0f);
-		v.Format("CTF_C%02d_Team0z",CTFClass);
-		CTFPedPos[0].Z = SSGMIni->Get_Float("CTF",v,0.0f);
-		v.Format("CTF_C%02d_Team1x",CTFClass);
-		CTFPedPos[1].X = SSGMIni->Get_Float("CTF",v,0.0f);
-		v.Format("CTF_C%02d_Team1y",CTFClass);
-		CTFPedPos[1].Y = SSGMIni->Get_Float("CTF",v,0.0f);
-		v.Format("CTF_C%02d_Team1z",CTFClass);
-		CTFPedPos[1].Z = SSGMIni->Get_Float("CTF",v,0.0f);
+		v.Format("CTF_C%02d_Name",mapConfiguration.CTFClass);
+		SSGMIni->Get_String(mapConfiguration.CTFClassName,v,mapConfiguration.CTFClassName);
+		v.Format("CTF_C%02d_Reverse",mapConfiguration.CTFClass);
+		mapConfiguration.CTFReverse = SSGMIni->Get_Bool(key,v,mapConfiguration.CTFReverse);
+		v.Format("CTF_C%02d_CaptureLimit",mapConfiguration.CTFClass);
+		mapConfiguration.CTFCapLimit = SSGMIni->Get_Int(key,v,mapConfiguration.CTFCapLimit);
+		v.Format("CTF_C%02d_Team0x",mapConfiguration.CTFClass);
+		mapConfiguration.CTFPedPos[0].X = SSGMIni->Get_Float(key,v,mapConfiguration.CTFPedPos[0].X);
+		v.Format("CTF_C%02d_Team0y",mapConfiguration.CTFClass);
+		mapConfiguration.CTFPedPos[0].Y = SSGMIni->Get_Float(key,v,mapConfiguration.CTFPedPos[0].Y);
+		v.Format("CTF_C%02d_Team0z",mapConfiguration.CTFClass);
+		mapConfiguration.CTFPedPos[0].Z = SSGMIni->Get_Float(key,v,mapConfiguration.CTFPedPos[0].Z);
+		v.Format("CTF_C%02d_Team1x",mapConfiguration.CTFClass);
+		mapConfiguration.CTFPedPos[1].X = SSGMIni->Get_Float(key,v,mapConfiguration.CTFPedPos[1].X);
+		v.Format("CTF_C%02d_Team1y",mapConfiguration.CTFClass);
+		mapConfiguration.CTFPedPos[1].Y = SSGMIni->Get_Float(key,v,mapConfiguration.CTFPedPos[1].Y);
+		v.Format("CTF_C%02d_Team1z",mapConfiguration.CTFClass);
+		mapConfiguration.CTFPedPos[1].Z = SSGMIni->Get_Float(key,v,mapConfiguration.CTFPedPos[1].Z);
 	}
 	void Set_Flag_Location(int Team, int Loc)
 	{
@@ -211,10 +253,10 @@
 		CTFFlagAttached[Team][0] = 0;
 		CTFFlagAttached[Team][1] = 0;
 		Vector3 FlagLoc = Position;
-		FlagLoc += CTFFlagOffset;
-		GameObject *Flag = Commands->Create_Object(CTFFlagPreset,FlagLoc);
+		FlagLoc += mapConfiguration.CTFFlagOffset;
+		GameObject *Flag = Commands->Create_Object(mapConfiguration.CTFFlagPreset,FlagLoc);
 		Commands->Set_Player_Type(Flag,Team);
-		Commands->Set_Model(Flag,CTFFlagModel[Team]);
+		Commands->Set_Model(Flag,mapConfiguration.CTFFlagModel[Team]);
 		Commands->Attach_Script(Flag,"SSGM_CTF_DropFlag","");
 		Commands->Attach_Script(Flag,"KAK_Prevent_Kill","");
 		Set_Flag_Location(Team,3);
@@ -229,11 +271,11 @@
 		CTFFlagHolder[Team] = 0;
 		CTFFlagAttached[Team][0] = 0;
 		CTFFlagAttached[Team][1] = 0;
-		Vector3 FlagLoc = CTFPedPos[Team];
-		FlagLoc += CTFFlagOffset;
-		GameObject *Flag = Commands->Create_Object(CTFFlagPreset,FlagLoc);
+		Vector3 FlagLoc = mapConfiguration.CTFPedPos[Team];
+		FlagLoc += mapConfiguration.CTFFlagOffset;
+		GameObject *Flag = Commands->Create_Object(mapConfiguration.CTFFlagPreset,FlagLoc);
 		Commands->Set_Player_Type(Flag,Team);
-		Commands->Set_Model(Flag,CTFFlagModel[Team]);
+		Commands->Set_Model(Flag,mapConfiguration.CTFFlagModel[Team]);
 		Commands->Attach_Script(Flag,"MDB_SSGM_CTF_Flag","");
 		Commands->Attach_Script(Flag,"KAK_Prevent_Kill","");
 		Set_Flag_Location(Team,1);
@@ -245,12 +287,12 @@
 		{
 			return 0;
 		}
-		Vector3 PedPos = CTFPedPos[Team];
-		GameObject *Ped = Commands->Create_Object(CTFPedPreset[Team],PedPos);
+		Vector3 PedPos = mapConfiguration.CTFPedPos[Team];
+		GameObject *Ped = Commands->Create_Object(mapConfiguration.CTFPedPreset[Team],PedPos);
 		Commands->Set_Player_Type(Ped,Team);
 		Commands->Attach_Script(Ped,"KAK_Prevent_Kill","");
 		Create_CTF_PedFlag(Team);
-		PedPos.Z += CTFFlagOffset.Z;
+		PedPos.Z += mapConfiguration.CTFFlagOffset.Z;
 		PedPos.Z += 1.25f;
 		GameObject *Icon = Commands->Create_Object("Invisible_Object",PedPos);
 		CTFFlagIcon[Team] = Commands->Get_ID(Icon);
@@ -331,12 +373,12 @@
 			StringClass tmp;
 			tmp.Format("msg %s",Msg.Peek_Buffer());
 			Console_Input(tmp);
-			if (CTFCapLimit > 0)
+			if (mapConfiguration.CTFCapLimit > 0)
 			{
-				if ((CTFCapLimit - CTFCaps[Get_Object_Type(Player1)]) > 0) {
+				if ((mapConfiguration.CTFCapLimit - CTFCaps[Get_Object_Type(Player1)]) > 0) {
 					const char *str = Get_Team_Name(Get_Object_Type(Player1));
 					const char *str2 = Get_Team_Name(Team);
-					Msg.Format("%s needs to capture the %s flag %d more time(s) to win.",str,str2,(CTFCapLimit - CTFCaps[Get_Object_Type(Player1)]));
+					Msg.Format("%s needs to capture the %s flag %d more time(s) to win.",str,str2,(mapConfiguration.CTFCapLimit - CTFCaps[Get_Object_Type(Player1)]));
 					delete[] str;
 					delete[] str2;
 					SSGMGameLog::Log_Message(Msg,"_CTF");
@@ -348,7 +390,7 @@
 				{
 					const char *str = Get_Team_Name(Get_Object_Type(Player1));
 					const char *str2 = Get_Team_Name(Team);
-					Msg.Format("%s has won the game by capturing the %s flag %d time(s)!",str,str2,CTFCapLimit);
+					Msg.Format("%s has won the game by capturing the %s flag %d time(s)!",str,str2,mapConfiguration.CTFCapLimit);
 					delete[] str;
 					delete[] str2;
 					SSGMGameLog::Log_Message(Msg,"_CTF");
@@ -402,7 +444,7 @@
 				StringClass tmp;
 				const char *str = Get_Team_Name(0);
 				const char *str2 = Get_Team_Name(1);
-				tmp.Format("ppage %d %s Flag Captures: %d/%d - %s Flag Captures: %d/%d",PlayerID,str,CTFCaps[0],CTFCapLimit,str2,CTFCaps[1],CTFCapLimit);
+				tmp.Format("ppage %d %s Flag Captures: %d/%d - %s Flag Captures: %d/%d",PlayerID,str,CTFCaps[0],mapConfiguration.CTFCapLimit,str2,CTFCaps[1],mapConfiguration.CTFCapLimit);
 				delete[] str;
 				delete[] str2;
 				return false;
@@ -432,7 +474,7 @@
 				StringClass tmp;
 				const char *str = Get_Team_Name(0);
 				const char *str2 = Get_Team_Name(1);
-				tmp.Format("ppage %d The %s flag is %s. The %s flag is %s. The class is '%s'.",PlayerID,str,Msg[0].Peek_Buffer(),str2,Msg[1].Peek_Buffer(),CTFClassName);
+				tmp.Format("ppage %d The %s flag is %s. The %s flag is %s. The class is '%s'.",PlayerID,str,Msg[0].Peek_Buffer(),str2,Msg[1].Peek_Buffer(),mapConfiguration.CTFClassName);
 				delete[] str;
 				delete[] str2;
 				Console_Input(tmp);
@@ -453,15 +495,15 @@
 	{
 		PickedUp = false;
 		int Team = Get_Object_Type(obj);
-		if (ctf.CTFFriendlyFlagRadar) {
-			GameObject *AttachedFlag = Commands->Create_Object_At_Bone(obj,ctf.CTFFlagBackPreset,"Origin");
+		if (ctf.mapConfiguration.CTFFriendlyFlagRadar) {
+			GameObject *AttachedFlag = Commands->Create_Object_At_Bone(obj,ctf.mapConfiguration.CTFFlagBackPreset,"Origin");
 			Commands->Attach_To_Object_Bone(AttachedFlag, obj,"Origin");
 			Commands->Disable_All_Collisions(AttachedFlag);
 			Commands->Set_Player_Type(AttachedFlag,Team);
 			Commands->Set_Model(AttachedFlag,"null");
 			ctf.CTFFlagAttached[Team][0] = Commands->Get_ID(AttachedFlag);
 		}
-		if (ctf.CTFEnemyFlagRadar) {
+		if (ctf.mapConfiguration.CTFEnemyFlagRadar) {
 			GameObject *AttachedFlag2 = Commands->Create_Object_At_Bone(obj,"Invisible_Object","Origin");
 			Commands->Attach_To_Object_Bone(AttachedFlag2, obj, "Origin");
 			Commands->Disable_All_Collisions(AttachedFlag2);
@@ -501,16 +543,16 @@
 					ctf.CTFFlagAttached[OtherTeam][0] = 0;
 					ctf.CTFCaps[Team]++;
 					ctf.CTF_Message(6,OtherTeam,sender,0);	
-					Commands->Give_Points(sender,ctf.CTFCapPoints,false);
-					Commands->Give_Money(sender,(ctf.CTFCapPoints*-1.0f),false);
-					Commands->Give_Points(sender,ctf.CTFCapPointsTeam,true);
-					Commands->Give_Money(sender,(ctf.CTFCapPointsTeam*-1.0f),true);
-					Commands->Give_Money(sender,ctf.CTFCapMoney,false);	
-					Commands->Give_Money(sender,ctf.CTFCapMoneyTeam,true);
+					Commands->Give_Points(sender,ctf.mapConfiguration.CTFCapPoints,false);
+					Commands->Give_Money(sender,(ctf.mapConfiguration.CTFCapPoints*-1.0f),false);
+					Commands->Give_Points(sender,ctf.mapConfiguration.CTFCapPointsTeam,true);
+					Commands->Give_Money(sender,(ctf.mapConfiguration.CTFCapPointsTeam*-1.0f),true);
+					Commands->Give_Money(sender,ctf.mapConfiguration.CTFCapMoney,false);	
+					Commands->Give_Money(sender,ctf.mapConfiguration.CTFCapMoneyTeam,true);
 					int AnimSize = (sizeof(CTFAnimations)/sizeof(char*));
 					int Animation2Play = Commands->Get_Random_Int(0,AnimSize);
 					Commands->Set_Animation(sender,CTFAnimations[Animation2Play],false,0,0.0f,-1.0f,false);
-					if (ctf.CTFCaps[Team] >= ctf.CTFCapLimit)
+					if (ctf.CTFCaps[Team] >= ctf.mapConfiguration.CTFCapLimit)
 					{
 						StringClass str;
 						str.Format("WIN %d\n",Team);
@@ -532,16 +574,16 @@
 	{
 		PickedUp = false;
 		int Team = Get_Object_Type(obj);
-		if (ctf.CTFFriendlyFlagRadar)
+		if (ctf.mapConfiguration.CTFFriendlyFlagRadar)
 		{
-			GameObject *AttachedFlag = Commands->Create_Object_At_Bone(obj,ctf.CTFFlagBackPreset,"Origin");
+			GameObject *AttachedFlag = Commands->Create_Object_At_Bone(obj,ctf.mapConfiguration.CTFFlagBackPreset,"Origin");
 			Commands->Attach_To_Object_Bone(AttachedFlag, obj,"Origin");
 			Commands->Disable_All_Collisions(AttachedFlag);
 			Commands->Set_Player_Type(AttachedFlag,Team);
 			Commands->Set_Model(AttachedFlag,"null");
 			ctf.CTFFlagAttached[Team][0] = Commands->Get_ID(AttachedFlag);
 		}	
-		if (ctf.CTFEnemyFlagRadar)
+		if (ctf.mapConfiguration.CTFEnemyFlagRadar)
 		{
 			GameObject *AttachedFlag2 = Commands->Create_Object_At_Bone(obj,"Invisible_Object","Origin");
 			Commands->Attach_To_Object_Bone(AttachedFlag2, obj, "Origin");
@@ -552,9 +594,9 @@
 			Commands->Set_Obj_Radar_Blip_Color(AttachedFlag2,Team);
 			ctf.CTFFlagAttached[Team][1] = Commands->Get_ID(AttachedFlag2);
 		}
-		if (ctf.CTFReturnTime > 0.0f)
+		if (ctf.mapConfiguration.CTFReturnTime > 0.0f)
 		{
-			Commands->Start_Timer(obj,this,ctf.CTFReturnTime,1);
+			Commands->Start_Timer(obj,this,ctf.mapConfiguration.CTFReturnTime,1);
 		}
 		((PowerUpGameObjDef &)(obj->As_PhysicalGameObj()->As_PowerUpGameObj()->Get_Definition())).Persistent = true;
 		((PowerUpGameObjDef &)(obj->As_PhysicalGameObj()->As_PowerUpGameObj()->Get_Definition())).AlwaysAllowGrant = true;
@@ -609,10 +651,10 @@
 		int Team = PTTEAM(Get_Object_Type(obj));
 		Commands->Destroy_Object(Commands->Find_Object(ctf.CTFFlagAttached[Team][0]));
 		Commands->Destroy_Object(Commands->Find_Object(ctf.CTFFlagAttached[Team][1]));
-		GameObject *AttachedFlag = Commands->Create_Object_At_Bone(obj,ctf.CTFFlagBackPreset,"bone for bag");
+		GameObject *AttachedFlag = Commands->Create_Object_At_Bone(obj,ctf.mapConfiguration.CTFFlagBackPreset,"bone for bag");
 		Commands->Attach_To_Object_Bone(AttachedFlag,obj,"bone for bag");
 		Commands->Disable_All_Collisions(AttachedFlag);
-		if (ctf.CTFFriendlyFlagRadar)
+		if (ctf.mapConfiguration.CTFFriendlyFlagRadar)
 		{
 			Commands->Set_Player_Type(AttachedFlag,Team);
 		}
@@ -620,9 +662,9 @@
 		{
 			Commands->Set_Player_Type(AttachedFlag,-2);
 		}
-		Commands->Set_Model(AttachedFlag,ctf.CTFFlagModel[Team]);
+		Commands->Set_Model(AttachedFlag,ctf.mapConfiguration.CTFFlagModel[Team]);
 		ctf.CTFFlagAttached[Team][0] = Commands->Get_ID(AttachedFlag);
-		if (ctf.CTFEnemyFlagRadar)
+		if (ctf.mapConfiguration.CTFEnemyFlagRadar)
 		{
 			GameObject *AttachedFlag2 = Commands->Create_Object_At_Bone(obj,"Invisible_Object","bone for bag");
 			Commands->Attach_To_Object_Bone(AttachedFlag2,obj,"bone for bag");
@@ -633,7 +675,7 @@
 			Commands->Set_Obj_Radar_Blip_Color(AttachedFlag2,Team);
 			ctf.CTFFlagAttached[Team][1] = Commands->Get_ID(AttachedFlag2);
 		}
-		if (ctf.CTFRegenForHolder)
+		if (ctf.mapConfiguration.CTFRegenForHolder)
 		{
 			Commands->Start_Timer(obj,this,1.0f,1);
 		}
@@ -670,7 +712,7 @@
 	{
 		if (number == 1 && Commands->Get_Health(obj) > 0.0f)
 		{
-			Commands->Apply_Damage(obj,(ctf.CTFRegenAmount * -1.0f),"Repair",0);
+			Commands->Apply_Damage(obj,(ctf.mapConfiguration.CTFRegenAmount * -1.0f),"Repair",0);
 			Commands->Start_Timer(obj,this,1.0f,1);
 		}
 		else if (number == 2)
@@ -700,8 +742,8 @@
 	void Timer_Expired(GameObject *obj, int number)
 	{
 		StringClass str;
-		str.Format("msg Running in Capture The Flag mode. This rounds CTF class will be '%s' with a capture limit of %d.",ctf.CTFClassName.Peek_Buffer(),ctf.CTFCapLimit);
-		if (ctf.CTFReverse)
+		str.Format("msg Running in Capture The Flag mode. This rounds CTF class will be '%s' with a capture limit of %d.",ctf.mapConfiguration.CTFClassName.Peek_Buffer(),ctf.mapConfiguration.CTFCapLimit);
+		if (ctf.mapConfiguration.CTFReverse)
 		{
 			Console_Input("msg This is a Reverse CTF game. Your objective is to take the enemy flag from your base and run it to your pedestal in the enemy base.");
 			Console_Input("msg Keep in mind that returning your own flag is not always the best course of action!");
diff -uwr sourceold/ExtraConsoleCommands/ExtraConsoleCommands.cpp source/ExtraConsoleCommands/ExtraConsoleCommands.cpp
--- sourceold/ExtraConsoleCommands/ExtraConsoleCommands.cpp	2011-10-11 21:33:41.248046800 +0800
+++ source/ExtraConsoleCommands/ExtraConsoleCommands.cpp	2011-11-07 20:10:56.345703100 +0800
@@ -632,18 +632,19 @@
 	~EXTRACONSOLECOMMANDS()
 	{
 		Console_Output("Un-loading Extra Console Commands Plugin; written by Reborn from MP-Gaming.COM\n");
-		const DynamicVectorClass<ConsoleFunctionClass*> consoleFunctions(ConsoleFunctionList);
-		TT_FOREACH(consoleFunction, consoleFunctions)
-		{
-			const char* name = (*consoleFunction)->Get_Name();
-			if (name)
-			{
-				if (strcmp(name, "GiveCredits") == 0 || strcmp(name, "TakeCredits") == 0 || strcmp(name, "Kill") == 0 || strcmp(name, "Fly") == 0 || strcmp(name, "GivePoints") == 0 || strcmp(name, "TakePoints") == 0 || strcmp(name, "GivePow") == 0 || strcmp(name, "ChangeChar") == 0 || strcmp(name, "AttachScript") == 0 || strcmp(name, "UnAttachScript") == 0 || strcmp(name, "FreezePlayer") == 0 || strcmp(name, "UnFreezePlayer") == 0 || strcmp(name, "ListPlayersObjectIDs") == 0)
-				{
-					ConsoleFunctionList.Delete(consoleFunction);
-				}
-			}
-		}
+		Delete_Console_Function("GiveCredits");
+		Delete_Console_Function("TakeCredits");
+		Delete_Console_Function("Kill");
+		Delete_Console_Function("Fly");
+		Delete_Console_Function("GivePoints");
+		Delete_Console_Function("TakePoints");
+		Delete_Console_Function("GivePow");
+		Delete_Console_Function("ChangeChar");
+		Delete_Console_Function("AttachScript");
+		Delete_Console_Function("UnAttachScript");
+		Delete_Console_Function("FreezePlayer");
+		Delete_Console_Function("UnFreezePlayer");
+		Delete_Console_Function("ListPlayersObjectIDs");
 	}
 	
 };
diff -uwr sourceold/Mute/Mute.cpp source/Mute/Mute.cpp
--- sourceold/Mute/Mute.cpp	2011-10-11 21:35:34.633789000 +0800
+++ source/Mute/Mute.cpp	2011-11-07 20:10:56.260742100 +0800
@@ -126,19 +126,8 @@
 		UnregisterEvent(EVENT_CHAT_HOOK,this);
 		UnregisterEvent(EVENT_RADIO_HOOK,this);
 		UnregisterEvent(EVENT_PLAYER_LEAVE_HOOK,this);
-		const DynamicVectorClass<ConsoleFunctionClass*> consoleFunctions(ConsoleFunctionList);
-		TT_FOREACH(consoleFunction, consoleFunctions)
-		{
-			const char* name = (*consoleFunction)->Get_Name();
-			if (name)
-			{
-				if (strcmp(name, "Mute") == 0 ||
-					strcmp(name, "UnMute") == 0)
-				{
-					ConsoleFunctionList.Delete(consoleFunction);
-				}
-			}
-		}
+		Delete_Console_Function("Mute");
+		Delete_Console_Function("UnMute");
 	}
 
 
diff -uwr sourceold/PointsDistribution/DamagePoints.cpp source/PointsDistribution/DamagePoints.cpp
--- sourceold/PointsDistribution/DamagePoints.cpp	2011-10-11 21:36:03.346679600 +0800
+++ source/PointsDistribution/DamagePoints.cpp	2011-11-26 08:54:08.804687500 +0800
@@ -16,6 +16,16 @@
  
 void CollectDamage::Created(GameObject *obj)
 {
+	/*
+	if((strcmp(Commands->Get_Preset_Name(obj),"Destructible_Under_Pass"))== 0)
+	{
+		Set_Death_Points(obj, 0);
+		Set_Damage_Points(obj, 0);
+		StringClass msg;
+		msg.Format("Fixing broken preset values for \"Destructible_Under_Pass\".\n");
+		Console_Output(msg);
+	}
+	*/
 	if(Get_Death_Points(obj) == 0 && Get_Damage_Points(obj) == 0)
 	{
 		return;
@@ -41,6 +51,8 @@
  
 void CollectDamage::Killed(GameObject *obj, GameObject *Killer)
 {
+	if(Commands->Get_Player_Type(obj) == 0 || Commands->Get_Player_Type(obj) == 1)
+	{
 	float TotalDamage;
 	TotalDamage = 0;
 	for(int i = 0; i < 128; i++)
@@ -60,6 +72,7 @@
 		}
 	}
 }
+}
 
 
 ScriptRegistrant<CollectDamage> CollectDamage_Registrant("CollectDamage","");
diff -uwr sourceold/PointsDistribution/PointsDistribution.cpp source/PointsDistribution/PointsDistribution.cpp
--- sourceold/PointsDistribution/PointsDistribution.cpp	2011-10-11 21:36:13.567382800 +0800
+++ source/PointsDistribution/PointsDistribution.cpp	2011-11-26 08:54:08.823242100 +0800
@@ -65,6 +65,11 @@
 		{
 			Attach_Script_Once(obj,"CollectDamage","");
 		}
+		/*
+		StringClass msg;
+		msg.Format("Preset name:%s\nDeath Points: %f\nDamage Points:%f\nHealth: %f\nArmor: %f\nSkin: %s\n", Commands->Get_Preset_Name(obj), Get_Death_Points(obj), Get_Damage_Points(obj), Commands->Get_Health(obj), Commands->Get_Shield_Strength(obj), Get_Skin(obj));
+		Console_Output(msg);
+		*/
 	}
 };
 
diff -uwr sourceold/Spectate/Spectate.cpp source/Spectate/Spectate.cpp
--- sourceold/Spectate/Spectate.cpp	2011-10-11 23:03:06.380859300 +0800
+++ source/Spectate/Spectate.cpp	2011-11-07 20:10:56.307617100 +0800
@@ -126,18 +126,8 @@
 	~SPECTATE()
 	{
 		Console_Output("Un-loading Spectate Plugin; written by Reborn from MP-Gaming.COM\n");
-		const DynamicVectorClass<ConsoleFunctionClass*> consoleFunctions(ConsoleFunctionList);
-		TT_FOREACH(consoleFunction, consoleFunctions)
-		{
-			const char* name = (*consoleFunction)->Get_Name();
-			if (name)
-			{
-				if (strcmp(name, "Spectate") == 0 || strcmp(name, "SpectateSpeed") == 0)
-				{
-					ConsoleFunctionList.Delete(consoleFunction);
-				}
-			}
-		}
+		Delete_Console_Function("Spectate");
+		Delete_Console_Function("SpectateSpeed");
 	}
 	
 };
diff -uwr sourceold/SuddenDeath/SuddenDeath.cpp source/SuddenDeath/SuddenDeath.cpp
--- sourceold/SuddenDeath/SuddenDeath.cpp	2011-10-11 23:03:00.555664000 +0800
+++ source/SuddenDeath/SuddenDeath.cpp	2011-11-07 20:10:56.581054600 +0800
@@ -76,18 +76,7 @@
 	~SUDDENDEATH()
 	{
 		Console_Output("Un-Loading Sudden Death Plugin; written by Reborn from MP-Gaming.COM\n");
-		const DynamicVectorClass<ConsoleFunctionClass*> consoleFunctions(ConsoleFunctionList);
-		TT_FOREACH(consoleFunction, consoleFunctions)
-		{
-			const char* name = (*consoleFunction)->Get_Name();
-			if (name)
-			{
-				if (strcmp(name, "SuddenDeath") == 0)
-				{
-					ConsoleFunctionList.Delete(consoleFunction);
-				}
-			}
-		}
+		Delete_Console_Function("SuddenDeath");
 		UnregisterEvent(EVENT_GLOBAL_INI,this);
 		UnregisterEvent(EVENT_LOAD_LEVEL_HOOK,this);
 		UnregisterEvent(EVENT_OBJECT_CREATE_HOOK,this);
diff -uwr sourceold/bansystem/bansystem.cpp source/bansystem/bansystem.cpp
--- sourceold/bansystem/bansystem.cpp	2011-10-11 21:31:27.529296800 +0800
+++ source/bansystem/bansystem.cpp	2011-11-07 20:10:56.543945300 +0800
@@ -119,20 +119,9 @@
 BanSystem::~BanSystem()
 {
 	UnregisterEvent(EVENT_GLOBAL_INI,this);
-	const DynamicVectorClass<ConsoleFunctionClass*> consoleFunctions(ConsoleFunctionList);
-	TT_FOREACH(consoleFunction, consoleFunctions)
-	{
-		const char* name = (*consoleFunction)->Get_Name();
-		if (name)
-		{
-			if (strcmp(name, "kick") == 0 ||
-				strcmp(name, "ban") == 0 ||
-				strcmp(name, "rehash_ban_list") == 0)
-			{
-				ConsoleFunctionList.Delete(consoleFunction);
-			}
-		}
-	}
+	Delete_Console_Function("kick");
+	Delete_Console_Function("ban");
+	Delete_Console_Function("rehash_ban_list");
 	
 	removeConnectionAcceptanceFilter(this);
 }
Files sourceold/bin/Debug/shaders.lib and source/bin/Debug/shaders.lib differ
Files sourceold/bin/Release/shaders.lib and source/bin/Release/shaders.lib differ
